Package org.eclipse.microprofile.openapi.annotations.headers

# Annotation Type Header

@Target({}) @Retention(RUNTIME) @Inherited public @interface Header
Describes a single header object

See Also:
  - OpenAPI Specification Header Object

## Optional Element Summary

Optional Elements
Modifier and Type
Optional Element
Description
`boolean`
`allowEmptyValue`
When true, allows sending an empty value.
`boolean`
`deprecated`
Specifies that a header is deprecated and should be transitioned out of usage.
`String`
`description`
Additional description data to provide on the purpose of the header
`Extension[]`
`extensions`
List of extensions to be added to the `Header` model corresponding to the containing annotation.
`String`
`name`
The name of the header.
`String`
`ref`
Reference value to a Header object.
`boolean`
`required`
Determines whether this header is mandatory.
`Schema`
`schema`
The schema defining the type used for the header.

## Element Details

### name

String name
The name of the header. The name is only used as the key to add this header to a map.

It is a REQUIRED property unless this is only a reference to a header instance.

When the header is defined within `Components`, the name will be used as the key to add this header to the 'headers' map for reuse.

Returns:
  this header's name

Default:
  ""

### description

String description
Additional description data to provide on the purpose of the header

Returns:
  the header's description

Default:
  ""

### schema

Schema schema
The schema defining the type used for the header. Ignored if the properties content or array are specified.

Returns:
  the schema of the header

Default:
  @org.eclipse.microprofile.openapi.annotations.media.Schema

### required

boolean required
Determines whether this header is mandatory. The property may be included and its default value is false.

Returns:
  whether or not the header is required

Default:
  false

### deprecated

boolean deprecated
Specifies that a header is deprecated and should be transitioned out of usage.

Returns:
  whether or not the header is deprecated

Default:
  false

### allowEmptyValue

boolean allowEmptyValue
When true, allows sending an empty value. If false, the header will be considered \"null\" if no value is present. This may create validation errors when the header is required.

Returns:
  whether or not the header allows empty values

Default:
  false

### ref

String ref
Reference value to a Header object.

This property provides a reference to an object defined elsewhere. This property and all other properties are mutually exclusive. If other properties are defined in addition to the ref property then the result is undefined.

Returns:
  reference to a header

Default:
  ""

### extensions

Extension[] extensions
List of extensions to be added to the `Header` model corresponding to the containing annotation.

Returns:
  array of extensions
Since:
  3.1

Default:
  {}